=== Eigen/src/SparseQR/CMakeLists.txt ===
FILE(GLOB Eigen_SparseQR_SRCS "*.h")

INSTALL(FILES
  ${Eigen_SparseQR_SRCS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/Eigen/src/SparseQR/ COMPONENT Devel
  )
