=== debian/changelog ===
eigen3 (3.2.0-8) unstable; urgency=medium

  * [93ce22f] Add Provides section for eigen2 package. 
              Prepare for eigen2 removal.

 -- Anton Gladky <gladk@debian.org>  Wed, 05 Feb 2014 19:45:59 +0100

eigen3 (3.2.0-7) unstable; urgency=medium

  [ Philipp Büttgenbach ]
  * [2311eec] Fix spline module. (Closes: #736985)

  [ Anton Gladky ]
  * [acab013] Remove piwik scripts.
  * [dd630a6] Ignore quilt dir

 -- Anton Gladky <gladk@debian.org>  Thu, 30 Jan 2014 21:53:10 +0100

eigen3 (3.2.0-6) unstable; urgency=medium

  * [6d44773] Add libmrpt-dev to Suggests section of libeigen3-dev. 
              (Closes: #731050)
  * [c700ee9] Bump Standards-Version: 3.9.5. No changes.
  * [38ab047] Port unsupported constrained CG to Eigen3. 
              Thanks to Gael Guennebaud <gael.guennebaud@gmail.com>
  * [d8b7945] Remove build type check in cmake.

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Jan 2014 22:17:03 +0100

eigen3 (3.2.0-5) unstable; urgency=low

  * [f9969f0] Remove BVH_example (segfault).
  * [d3e62d1] Install FindEigen3.cmake into /usr/share/cmake-2.8/Modules 
              not to duplicate it in many packages.
  * [c7dd8d6] Use wrap-and-sort.

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Nov 2013 21:48:09 +0100

eigen3 (3.2.0-4) unstable; urgency=low

  * [f512ba5] Revert libeigen3-dev arch to "all" again.

 -- Anton Gladky <gladk@debian.org>  Tue, 06 Aug 2013 18:42:30 +0200

eigen3 (3.2.0-3) unstable; urgency=low

  * [a8692a3] Remove all third-party math-packages from Build-Depends.
              Only the basic functionality of the package will be tested.

 -- Anton Gladky <gladk@debian.org>  Tue, 30 Jul 2013 17:25:24 +0200

eigen3 (3.2.0-2) unstable; urgency=low

  * [cc4e1eb] Use SSE-options only on archs, where it should be supported.

 -- Anton Gladky <gladk@debian.org>  Fri, 26 Jul 2013 08:38:02 +0200

eigen3 (3.2.0-1) unstable; urgency=low

  [ Bart Martens ]
  * [c61c475] Update debian/watch.

  [ Anton Gladky ]
  * [415b387] Imported Upstream version 3.2.0
  * [3d93cf4] Change libeigen3-dev architecture from "all" to "any" 
              to run autotests on all platforms.
  * [6d377ea] Suppress FTBFS if autotests failed. Build-logs will be analyzed 
              manually to notify upstream.
  * [37d22f4] Enable all possible test-options.
  * [f42c2d8] Update upstream changelog.
  * [060af1f] Use libmetis-dev instead of libscotch-dev.
  * [ff4d4ff] Remove ALTIVEC and NEON options.

 -- Anton Gladky <gladk@debian.org>  Thu, 25 Jul 2013 08:13:14 +0200

eigen3 (3.1.3-2) unstable; urgency=low

  * [53fdb1b] Use canonical VCS-field.
  * [b7f349f] Disable some unsupported unreliable tests. (Closes: #713758)
  * [1b9f29e] Add dependency on pkg-config. (Closes: #710915)

 -- Anton Gladky <gladk@debian.org>  Sun, 23 Jun 2013 21:05:30 +0200

eigen3 (3.1.3-1) unstable; urgency=low

  * [52a3539] Update dates in copyright.
  * [f22ef64] Return FTBFS if the autotest fails.
  * [60b2388] Respect nocheck option.

 -- Anton Gladky <gladk@debian.org>  Mon, 06 May 2013 20:58:32 +0200

eigen3 (3.1.3-1~exp1) experimental; urgency=low

  * [a1655c2] Imported Upstream version 3.1.3
  * [dd7e62a] Update upstream changelog.
  * [28c0a41] Remove applied by upstream patch.

 -- Anton Gladky <gladk@debian.org>  Tue, 16 Apr 2013 22:01:43 +0200

eigen3 (3.1.2-1~exp4) experimental; urgency=low

  * [8ec0e8a] Use autotests again, but only on maintainer`s machine.
  * [6b9b97d] Remove obsolete DM-Upload-Allowed flag.
  * [7b259f2] Disable mpreal test.
  * [93ac3ed] Bump Standards-Version: 3.9.4. No changes.
  * [97fc55c] Update Format-field in copyright-file.
  * [4e622d2] Update changelog.

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 24 Dec 2012 20:41:44 +0100
