=== debian/control ===
Source: eigen3
Section: libdevel
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>
Build-Depends:
 cmake (>= 2.6.2),
 debhelper (>= 9),
 gfortran,
 pkg-config
Build-Depends-Indep:
 doxygen-latex,
 ghostscript,
 graphviz,
 libjs-jquery,
 ttf-freefont
Standards-Version: 3.9.5
Homepage: http://eigen.tuxfamily.org
Vcs-Git: git://anonscm.debian.org/debian-science/packages/eigen3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/eigen3.git

Package: libeigen3-dev
Architecture: all
Depends:
 pkg-config,
 ${misc:Depends}
Provides: libeigen2-dev
Suggests:
 libeigen3-doc, libmrpt-dev
Description: lightweight C++ template library for linear algebra
 Eigen 3 is a lightweight C++ template library for vector and matrix math,
 a.k.a. linear algebra.
 .
 Unlike most other linear algebra libraries, Eigen 3 focuses on the simple
 mathematical needs of applications: games and other OpenGL apps, spreadsheets
 and other office apps, etc. Eigen 3 is dedicated to providing optimal speed
 with GCC. A lot of improvements since 2-nd version of Eigen.

Package: libeigen3-doc
Section: doc
Architecture: all
Depends:
 libjs-jquery,
 ttf-freefont,
 ${misc:Depends}
Provides: libeigen2-doc
Suggests:
 libeigen3-dev
Description: eigen3 API documentation
 Eigen 3 is a lightweight C++ template library for vector and matrix math,
 a.k.a. linear algebra.
 .
 This package provides the complete eigen3 API documentation in HTML format.
