=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)-(beta)/$1~$2/ \
http://eigen.tuxfamily.org/ .*/eigen/get/(\d\S+)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sun, 10 Mar 2013 20:58:43 +0000
